- name: Get existing upstreams
  uri:
    method: GET
    url: "https://api.{{ DOMAIN }}/apisix/admin/upstreams"
    return_content: yes
    headers:
      Accept: application/json
      X-API-KEY: "{{ inv_am.apisix.api_credentials.admin_role }}"
    status_code: 200
  register: upstreams

- name: Set fact upstream_exists to default value and API Documentation Docusaurus Upstream name
  set_fact:
    upstream_exists: false
    upstream_name: "{{ api_management_settings.documentation_docusaurus_upstream }}"

- name: Check if upstream for API Documentation Docusaurus API exists
  set_fact:
    documentation_docusaurus_upstream_id : "{{ item.value.id }}"
    upstream_exists: true
  when: item.value.name == upstream_name
  with_items: "{{ upstreams.json.list }}"

- name: Create Upstream for API Documentation Docusaurus API in APISiX
  uri:
    method: POST
    url: "https://api.{{ DOMAIN }}//apisix/admin/upstreams"
    return_content: yes
    body_format: json
    body: "{{ lookup('template', 'templates/10_api_management/apis/documentation_docusaurus/upstream.json.j2') }}"
    headers:
      Accept: application/json
      X-API-KEY: "{{ inv_am.apisix.api_credentials.admin_role }}"
    status_code: 201
  register: api_documentation_docusaurus_upstream
  when: not upstream_exists

- name : Set API Documentation Docusaurus Upstream ID
  set_fact:
    documentation_docusaurus_upstream_id: "{{ api_documentation_docusaurus_upstream.json.value.id }}"
  when: not upstream_exists

- name: Create Read Route for API Documentation Docusaurus API in APISiX
  uri:
    method: POST
    url: "https://api.{{ DOMAIN }}/apisix/admin/routes"
    return_content: yes
    body_format: json
    body: "{{ lookup('template', 'templates/10_api_management/apis/documentation_docusaurus/api_read_route.json.j2') }}"
    headers:
      Accept: application/json
      X-API-KEY: "{{ inv_am.apisix.api_credentials.admin_role }}"
    status_code: 201
  when: not upstream_exists


- name: Create Read Route for Documentation Docusaurus API in APISiX
  uri:
    method: POST
    url: "https://api.{{ DOMAIN }}/apisix/admin/routes"
    return_content: yes
    body_format: json
    body: "{{ lookup('template', 'templates/10_api_management/apis/documentation_docusaurus/doc_read_route.json.j2') }}"
    headers:
      Accept: application/json
      X-API-KEY: "{{ inv_am.apisix.api_credentials.admin_role }}"
    status_code: 201
  when: not upstream_exists




